% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/BayCount_Simulate_Data.R
\name{BayCount_sim}
\alias{BayCount_sim}
\title{Simulate data from BayCount model}
\usage{
BayCount_sim(G, S, K, Phi_par = 0.05, Theta_par = 0.5, zeta_par = 0.1,
  alpha_par = 0.1, p_max = 0.01)
}
\arguments{
\item{G}{number of genes}

\item{S}{number of tumor samples}

\item{K}{number of subclones}

\item{Phi_par}{shape parameter for the Dirichlet prior of the Phi_ik's}

\item{Theta_par}{shape parameter for the Dirichlet prior of the Theta_kj's}

\item{zeta_par}{rate parameter for the Gamma prior of the zeta_j's}

\item{alpha_par}{shape parameter for the Dirichlet prior of the alpha_i's}

\item{p_max}{upper bound for 1 - p, the success probability in the BayCount model}
}
\value{
A list of simulation truth object with observed matrix Y and parameters alpha, Phi, Theta, p_j's
}
\description{
This function generate data from the existing
}
\examples{
G = 100 # the number of genes
S = 20 # the number of samples
K = 3 # the number of subclones
simu_truth = BayCount_sim(G, S, K)

}
